SystemOrganization addCategory: #'TP2-SistemaEjemplo-Traits'!
SystemOrganization addCategory: #'TP2-SistemaEjemplo'!
SystemOrganization addCategory: #'TP2-SistemaEjemplo-Entities'!
SystemOrganization addCategory: #'TP2-SistemaEjemplo-UnitTest'!
SystemOrganization addCategory: #'TP2-SistemaEjemplo-Tests'!

Trait named: #TMalo
	uses: {}
	category: 'TP2-SistemaEjemplo-Traits'!

Trait named: #TTrait1
	uses: {}
	category: 'TP2-SistemaEjemplo-Traits'!

Trait named: #TTrait2
	uses: {}
	category: 'TP2-SistemaEjemplo-Traits'!

Trait named: #TTrait3
	uses: {}
	category: 'TP2-SistemaEjemplo-Traits'!

Object subclass: #Clase1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo'!

Object subclass: #Clase2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo'!

Object subclass: #Entity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo'!

Entity subclass: #Entity1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo-Entities'!

Entity subclass: #Entity2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo-Entities'!

Entity2 subclass: #Entity3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo-Entities'!

Entity3 subclass: #EntityBuena
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo-Entities'!

TestCase subclass: #TestArchitecture
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo-Tests'!

!TestArchitecture methodsFor: 'asserting' stamp: 'lucas 5/16/2012 16:41'!
classInHierachyOf: class subclass: subclass

	(subclass superclass == class) ifTrue: [^ true] ifFalse: 
	[(subclass superclass == Object) ifTrue: [^false] ifFalse: [^ (self classInHierachyOf: class subclass: (subclass superclass)) ]]

! !

!TestArchitecture methodsFor: 'accessing' stamp: 'lucas 5/16/2012 16:20'!
listClassesFrom: category
	^ SystemOrganization classesInCategory: category! !

!TestArchitecture methodsFor: 'accessing' stamp: 'lucas 5/16/2012 16:17'!
listElementsFrom: category
	
	^((SystemOrganization listAtCategoryNamed: category) collect: [:each | Smalltalk globals at: each] )! !

!TestArchitecture methodsFor: 'accessing' stamp: 'lucas 5/16/2012 16:45'!
listTraitsFrom: category
	^((SystemOrganization listAtCategoryNamed: category) collect: [:each | Smalltalk globals at: each]) select: [ :each | each isTrait ]! !

!TestArchitecture methodsFor: 'extensions' stamp: 'lucas 5/18/2012 17:50'!
nameOfClass: testName
	^ testName copyFrom: 5 to: (testName size) ! !

!TestArchitecture methodsFor: 'testing' stamp: 'lucas 5/18/2012 18:35'!
testCaseCorrectlyNamed
	| utestNames classNames|
	
	utestNames := ((self listClassesFrom: 'TP2-SistemaEjemplo-UnitTest') select: [ :c | c superclass == TestCase ])collect: [:ut | ut name] .
	
	classNames := (self listClassesFrom: 'TP2-SistemaEjemplo') collect: [:c | c name] .
	
	utestNames do: [ :utn | self assert: (classNames includes: (self nameOfClass: utn)) description:  'all unit test names must match "Test + <class name>"'].
	
	
! !

!TestArchitecture methodsFor: 'testing' stamp: 'lucas 5/18/2012 19:16'!
testClassesHaveDocumentation
	"compruebo que todas las clases tengan una documentacion (texto mayor a 5 caracteres)"
	| classes |
	
	classes  := self listClassesFrom: 'TP2-SistemaEjemplo'.
	
	"
	classes do: [ :c | self assert: (c classComment size > 4) description: 'the class must have a comment of 5 characters or more']
	"! !

!TestArchitecture methodsFor: 'testing' stamp: 'lucas 5/18/2012 18:30'!
testEachClassWithUnitTest
	| utestNames classNames|
	
	utestNames := (self listClassesFrom: 'TP2-SistemaEjemplo-UnitTest') collect: [:ut | ut name] .
	
	classNames := (self listClassesFrom: 'TP2-SistemaEjemplo') collect: [:c | c name] .
 
	classNames do: [ :cn | self assert: (utestNames includes: ('Test' , cn)) description: 'each class need a test case']! !

!TestArchitecture methodsFor: 'testing' stamp: 'lucas 5/16/2012 16:32'!
testEntitiesOnPackage
	| classes |
	
	classes := self listClassesFrom:   'TP2-SistemaEjemplo-Entities'.
	
	
	classes do: [:each | self assert: (self classInHierachyOf: Entity subclass: each)] 
	! !

!TestArchitecture methodsFor: 'testing' stamp: 'lucas 5/16/2012 16:44'!
testTraitsCorrectlyNamed
	| traitNames traits|
	
	traits := self listTraitsFrom:  'TP2-SistemaEjemplo-Traits'.
	traitNames := traits collect: [:t | t name].
	
	traitNames  do: [:tn |  self assert: $T equals: (tn first). 
		self assert: (tn size > 4) description: 'trait name must have 4 letters or more'.
		self assert: (tn second isUppercase) description: 'second letter of the trait name must be uppercase'.
		self assert: (tn third isLowercase ) description:  'third letter of the trait name must be lowercase']
	
	! !

!TestArchitecture methodsFor: 'testing' stamp: 'lucas 5/18/2012 18:31'!
traitsOnCorrectCategory
	"tengo que ver como conseguir todas las cosas de la app"
	| sysCategories categoriesWithoutTraits |
	
	sysCategories := SystemOrganization categories.
	
	Transcript show: sysCategories! !

TestCase subclass: #TestClase1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo-UnitTest'!

TestCase subclass: #TestClase2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo-UnitTest'!

TestCase subclass: #TestEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo-UnitTest'!
